﻿fileObj = new File(File.openDialog("タブ区切りテキストファイルを指定してください"));
TAB = String.fromCharCode(9);	// タブコード

//ダイアログで数値を設定
var myDiag=app.dialogs.add({name:"体裁に関する設定"});
with (myDiag.dialogColumns.add()) {

with (borderPanels.add()){
staticTexts.add({staticLabel:"【1】最大目盛り：", minWidth:80});
var maxVal=realEditboxes.add({editValue:200, minWidth:80});
staticTexts.add({staticLabel:"※充分に大きな値にすること"});
}
/*
with (borderPanels.add()){
staticTexts.add({staticLabel:"【2】最小目盛り：", minWidth:80});
var minVal=realEditboxes.add({editValue:0, minWidth:80});
staticTexts.add({staticLabel:"※基本は「0」"});
}
*/
with (borderPanels.add()){
staticTexts.add({staticLabel:"【2】換算率：数値"});
var cnvVal=realEditboxes.add({editValue:100, minWidth:80});
staticTexts.add({staticLabel:"をグラフ上で天地"});
var cnvMm=realEditboxes.add({editValue:20, minWidth:80});
staticTexts.add({staticLabel:"mmにする。"});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【3】棒の幅（mm）："});
var boWdth=realEditboxes.add({editValue:20, minWidth:80});
staticTexts.add({staticLabel:"mm"});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【4】棒と棒の間隔（mm）："});
var intvl=realEditboxes.add({editValue:10, minWidth:80});
staticTexts.add({staticLabel:"mm"});
}
}
myDiag.show();
maxVal=maxVal.editValue;
//minVal=minVal.editValue;
minVal=0;   //最小値はゼロに固定した。
cnv=cnvMm.editValue/cnvVal.editValue;
boWdth=boWdth.editValue;
intvl=intvl.editValue;

//ドキュメント作成と基本設定
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
while(!fileObj.eof) //行数と列数を知るために
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
countA++;
}
gHight=(maxVal-minVal)*cnv;    //グラフ高さ（目盛りの）
mgnBtm=50;  //下部アキ（目盛りの）
mgnLeft=30; //左側アキ（目盛りの）
mgnLeft2=5; //左側アキ（内側）
mgnRight=5;    //右側アキ（目盛りの）
mgnTp=(countA+1)*5;   //上部アキ（目盛りの上・数値表示用の領域）
ttlHight=mgnTp+gHight+mgnBtm;
ttlWidth=mgnLeft+intvl/2+boWdth*(txtItemA.length-1)+intvl*(txtItemA.length-2)+intvl/2+10;

myDoc = app.documents.add();
myDoc.documentPreferences.pageWidth = ttlWidth;
myDoc.documentPreferences.pageHeight = ttlHight;
myDoc.documentPreferences.facingPages=false; //見開きオフ
myDoc.documentPreferences.pageBinding = PageBindingOptions.leftToRight;//左から右
app.activeDocument.pages[0].marginPreferences.top=0;//マージン上
app.activeDocument.pages[0].marginPreferences.bottom=0;//マージン下
app.activeDocument.pages[0].marginPreferences.left=0;//マージン左
app.activeDocument.pages[0].marginPreferences.right=0;//マージン右
app.activeDocument.pages[0].marginPreferences.columnDirection = HorizontalOrVertical.horizontal;//文字組み方向-横
//ベースレイヤーの名称指定
app.activeDocument.layers[0].name="base";
//テキストレイヤーを追加
lay02=app.activeDocument.layers.add();
lay02.name="text";
//グラフレイヤーを追加
lay03=app.activeDocument.layers.add(); //レイヤーを追加
lay03.name="graph";  //レイヤー命名
//区分線レイヤーを追加
lay04=app.activeDocument.layers.add(); //レイヤーを追加
lay04.name="kubun_line";  //レイヤー命名

//段落スタイルを追加
app.documents[0].paragraphStyleGroups.add({name:"graph"});	//段落スタイルグループ
var numScalePrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"numScale"});	//数値目盛りの段落スタイル
numScalePrSt.pointSize = "10Q";
numScalePrSt.justification=1919379572; //右揃え

var btmScalePrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"btmScale"});	//下部目盛りの段落スタイル
btmScalePrSt.pointSize = "10Q";
//btmScalePrSt.justification=1667591796; //中央揃え

var valPrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"value"});	//数値の段落スタイル
valPrSt.pointSize = "10Q";
valPrSt.justification=1919379572; //右揃え

var valPrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"index"});	//見出しの段落スタイル
valPrSt.pointSize = "12Q";
//valPrSt.justification=1919379572; //右揃え
}

for( l = 1 ; l<countA ; l++){
//スウォッチを作成
app.activeDocument.colors.add({name:"gColor"+l , model:ColorModel.process,space:ColorSpace.cmyk,colorValue:[0, 0, 0, 60]});//スウォッチ
//文字スタイルを追加
var newChrctSt=app.documents[0].characterStyles.add({name:"Graph-"+l });	//文字スタイル
newChrctSt.fillColor = app.documents[0].swatches.itemByName("gColor"+l ); 
}



//X軸を作成
lnX = app.activeDocument.rectangles.add();
lnX.paths.item(0).entirePath = [[mgnLeft,mgnTp+gHight],[mgnLeft+intvl/2+boWdth*(txtItemA.length-1)+intvl*(txtItemA.length-2)+intvl/2,mgnTp+gHight]];
lnX.paths.item(0).pathType = PathType.openPath;
lnX.strokeWeight =0.25;
lnX.endCap=1919115632;    //丸形線端
lnX.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//Y軸を作成
lnY = app.activeDocument.rectangles.add();
lnY.paths.item(0).entirePath = [[mgnLeft,mgnTp],[mgnLeft,mgnTp+gHight]];
lnY.paths.item(0).pathType = PathType.openPath;
lnY.strokeWeight =0.25;
lnY.endCap=1919115632;    //丸形線端
lnY.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//Y軸上端の線を作成
lnYtp = app.activeDocument.rectangles.add();
lnYtp.paths.item(0).entirePath = [[mgnLeft-1,mgnTp],[mgnLeft,mgnTp]];
lnYtp.paths.item(0).pathType = PathType.openPath;
lnYtp.strokeWeight =0.25;
lnYtp.endCap=1919115632;    //丸形線端
lnYtp.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//Y軸下端の線を作成
lnYtp = app.activeDocument.rectangles.add();
lnYtp.paths.item(0).entirePath = [[mgnLeft-1,mgnTp+gHight],[mgnLeft,mgnTp+gHight]];
lnYtp.paths.item(0).pathType = PathType.openPath;
lnYtp.strokeWeight =0.25;
lnYtp.endCap=1919115632;    //丸形線端
lnYtp.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//最大値を作成
txtObjMax = app.activeDocument.textFrames.add();
txtObjMax.visibleBounds = [mgnTp-1.5,mgnLeft-26,mgnTp+1.5,mgnLeft-2];//上辺, 左辺, 下辺, 右辺
txtObjMax.contentType = ContentType.textType;
txtObjMax.contents = maxVal+"" ;    //文字列に変換した上で
txtObjMax.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;
txtObjMax.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("numScale");
txtObjMax.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//最小値を作成
txtObjMin = app.activeDocument.textFrames.add();
txtObjMin.visibleBounds = [mgnTp+gHight-1.5,mgnLeft-26,mgnTp+gHight+1.5,mgnLeft-2];//上辺, 左辺, 下辺, 右辺
txtObjMin.contentType = ContentType.textType;
txtObjMin.contents = minVal+"" ;    //文字列に変換した上で
txtObjMin.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;
txtObjMin.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("numScale");
txtObjMin.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

flag = fileObj.open("r");
if (flag)
{
text = fileObj.readln();    //1行よみこむ（ここでは1行目のみ）
txtItem = text.split(TAB);	//タブコードで分割
for(i=1 ; i<txtItem.length ; i++){
    
//X軸上の目盛りを作成
var xLt = mgnLeft+boWdth*(i-1)+intvl*(i-0.5);   //左辺座標
var xRt = xLt+boWdth;   //右辺座標

lnBtm = app.activeDocument.rectangles.add();
lnBtm.paths.item(0).entirePath = [[xRt+intvl/2,mgnTp+gHight-1],[xRt+intvl/2,mgnTp+gHight]];
lnBtm.paths.item(0).pathType = PathType.openPath;
lnBtm.strokeWeight =0.25;
lnBtm.endCap=1919115632;    //丸形線端
lnBtm.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//X軸の文字を作成
txtObjBtm = app.activeDocument.textFrames.add();
txtObjBtm.visibleBounds = [mgnTp+gHight+1,xLt,mgnTp+gHight+45,xRt];//上辺, 左辺, 下辺, 右辺
txtObjBtm.contentType = ContentType.textType;
txtObjBtm.contents = txtItem[i];
txtObjBtm.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;	//中央に
txtObjBtm.parentStory.storyPreferences.storyOrientation = HorizontalOrVertical.vertical;	//縦組みに
txtObjBtm.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("btmScale");
txtObjBtm.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

}
}

//ここからグラフと文字の作成

//処理のために配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
//alert(txtItemA);
ary.unshift(txtItemA);//配列の最初に行を追加
countA++;
}
}
var btmArray =[];   //下端Y座標の配列（順次書き換えて使用）

//alert(textA.length);

//alert(ary.length);

//ここから処理
for (var j = 0; j < ary.length-1; j++){
for (var k =0; k < ary[0].length; k++){
if(k==0){   //グラフの項目名処理
var yTp = 5*(ary.length-j-1);     //文字の上端
//見出し文字を作成
txtObjIndex = app.activeDocument.textFrames.add();
txtObjIndex.visibleBounds = [yTp,10,yTp+3,mgnLeft-1];//上辺, 左辺, 下辺, 右辺
txtObjIndex.contentType = ContentType.textType;
txtObjIndex.contents = ary[j][k] ;
ary[j][k] =Number(0);   //使い終わったら数値のゼロに
txtObjIndex.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;	//中央に
txtObjIndex.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("index");
txtObjIndex.paragraphs[0].appliedCharacterStyle=app.documents[0].characterStyles.itemByName("Graph-"+(ary.length-j-1));
txtObjIndex.move(app.documents[0].layers[app.activeDocument.layers.length-2]);

//凡例長方形
hnrRct = app.activeDocument.rectangles.add();
hnrRct.geometricBounds =[yTp,4,yTp+3,9];//上辺, 左辺, 下辺, 右辺
hnrRct.strokeWeight =0;
hnrRct.fillColor=app.activeDocument.swatches.itemByName("gColor"+(ary.length-j-1));
hnrRct.strokeColor=app.activeDocument.swatches.itemByName("None");
hnrRct.move(app.documents[0].layers[app.activeDocument.layers.length-2]);

}else{

var xLt2 = mgnLeft+(boWdth+intvl)*(k-1);   //領域の左辺座標
var xRt2 = xLt2+boWdth+intvl;   //領域の右辺座標

//数値文字を作成
txtObjVal = app.activeDocument.textFrames.add();
txtObjVal.visibleBounds = [yTp,xLt2,yTp+3,xRt2];//上辺, 左辺, 下辺, 右辺
txtObjVal.contentType = ContentType.textType;
txtObjVal.contents = ary[j][k];
txtObjVal.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;	//中央に
txtObjVal.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("value");
txtObjVal.paragraphs[0].appliedCharacterStyle=app.documents[0].characterStyles.itemByName("Graph-"+(ary.length-j-1));
txtObjVal.move(app.documents[0].layers[app.activeDocument.layers.length-2]);
val=mgnTp+gHight-(txtItem[i]-minVal)*cnv;　//値の座標
xVal=intvl*(i-1)+mgnLeft+mgnLeft2;　//横方向の座標

//グラフを作図
if (j==0){btmArray[k]=Number(0)}

var btmY = mgnTp+(maxVal-Number(btmArray[k]))*cnv;
var tpY = mgnTp+(maxVal-Number(ary[j][k])-Number(btmArray[k]))*cnv;

//棒部分の作成
if(ary[j][k] != 0){

newGraph = app.activeDocument.rectangles.add();
newGraph.geometricBounds =[tpY,xLt2+intvl/2,btmY,xRt2-intvl/2];//上辺, 左辺, 下辺, 右辺
newGraph.strokeWeight =0;
newGraph.fillColor=app.activeDocument.swatches.itemByName("gColor"+(ary.length-j-1));
newGraph.strokeColor=app.activeDocument.swatches.itemByName("None");
newGraph.move(app.documents[0].layers[app.activeDocument.layers.length-3]);
}

btmArray[k]=btmArray[k]+Number(ary[j][k]);  //配列の[k] のみを書き換え

//区分線の作成
if(k>1){
var kbnLt=xLt2-intvl/2;
var kbnRt=xLt2+intvl/2;
var kbY1=mgnTp+(maxVal-Number(btmArray[k-1]))*cnv;
var kbY2=mgnTp+(maxVal-Number(btmArray[k]))*cnv;

kbnLn = app.activeDocument.rectangles.add();
kbnLn.paths.item(0).entirePath = [[kbnLt,kbY1],[kbnRt,kbY2]];
kbnLn.paths.item(0).pathType = PathType.openPath;
kbnLn.strokeWeight =0.1;
kbnLn.endCap=1919115632;    //丸形線端
kbnLn.move(app.documents[0].layers[0]);

}
}
}
}
//ベースレイヤー（この時点では最背面）を最前面に移動
app.documents[0].layers[app.activeDocument.layers.length-1].move(LocationOptions.atBeginning);
//テキストレイヤー（この時点では最背面）を最前面に移動
app.documents[0].layers[app.activeDocument.layers.length-1].move(LocationOptions.atBeginning);